<%--
 * Component: cases
 *
 * Description:
 *    Download user profile for the viewer.
 *
 * Last Updated     : $Author$
 * Update Date Time : $Date$
 * RCS File Name    : $RCSfile$
 * RCS Revision     : $Revision$
 * Locked by        : $Locker$
 * Symbolic name    : $Name$
 * State            : $State$
--%><%@page import="javax.xml.transform.stream.StreamResult"%>
<%@page import="javax.xml.transform.dom.DOMSource"%>
<%@page import="javax.xml.transform.OutputKeys"%>
<%@page import="javax.xml.transform.Transformer"%>
<%@page import="javax.xml.transform.TransformerFactory"%>
<%@page import="org.w3c.dom.Element"%>
<%@page import="org.w3c.dom.Document"%>
<%@page import="javax.xml.parsers.DocumentBuilder"%>
<%@page import="javax.xml.parsers.DocumentBuilderFactory"%>
<%@
	page import="imagemed.util.*,java.io.*,java.sql.*, imagemed.imsession.*,java.util.*, imagemed.jsputil.*"

%><%@
	page errorPage ="../../main/exceptionHandler.jsp"

%><%
	IMSession is = new IMSession( request, response, out ); 

	if ( !is.regOK() ) {
		response.sendError( 403, "ERROR: invalid session" );
		return;
	}

	String confDir = IMEnvBase.getEnv( "CONF" );

	StringBuffer result = new StringBuffer( "" );

	String plugins = PluginToolbox.getPluginsData( is, PluginToolbox.PLATFORM_V8 );  
	if( plugins == null ) {
		return;  // invalid data, error header
	}

	DocumentBuilderFactory docFactory = DocumentBuilderFactory.newInstance();
	DocumentBuilder docBuilder;
	docBuilder = docFactory.newDocumentBuilder();
	Document doc = docBuilder.newDocument();

	String configtag = "config";

	Element configElement = doc.createElement( configtag );
	doc.appendChild( configElement );
	
	Element pluginsElement = doc.createElement( "plugins" );
	pluginsElement.setTextContent( plugins );
	configElement.appendChild( pluginsElement );

	Element serverElement = doc.createElement( "server" );
	configElement.appendChild( serverElement );

	Element guiformatElement = doc.createElement( "guiformat" );
	serverElement.appendChild( guiformatElement );

	ViewerProfileManager.createElementFromConfigFile( doc, guiformatElement, confDir + "/nameformat.cfg", "nameformat", true );

	ViewerProfileManager.createElementFromConfigFile( doc, guiformatElement, confDir + "/dateformat.cfg", "dateformat", true );

	ViewerProfileManager.createElementFromConfigFile( doc, guiformatElement, confDir + "/timeformat.cfg", "timeformat", true );

	ViewerProfileManager.createElementFromConfigFile( doc, serverElement, confDir + "/gui.conf", "gui", true );

	ViewerProfileManager.createElementFromConfigFile( doc, serverElement, confDir + "/institution", "institution", true );

	ViewerProfileManager.createElementFromConfigFile( doc, serverElement, confDir + "/fieldNames.rec", "fieldnames", true, "fieldnames-" );

	ViewerProfileManager.createElementFromConfigFile( doc, serverElement, confDir + "/fieldValues.rec", "fieldvalues", true, "fieldvalues-" );

	ViewerProfileManager.createElementFromConfigFile( doc, serverElement, IMEnvBase.getEnv( "DICOM_VAR" ) + "/mappings/global/viewer.map", "coercion", false );

	ViewerProfileManager.createElementsFromXMLFile( doc, docBuilder, serverElement, confDir + "/series_description_keywords.xml", "series_description_keywords" );

	ViewerProfileManager.createElementFromConfigFile( doc, serverElement, confDir + "/speech_recognition.cfg", "speech_recognition", false );

	DicomSrvToolbox.VersionInfo versionInfo = DicomSrvToolbox.getServerVersion();
	if ( versionInfo != null ) {
		Element versionElement = doc.createElement( "version" );
		versionElement.setTextContent( versionInfo.getVersion(  ) );
		serverElement.appendChild( versionElement );

		Element typeElement = doc.createElement( "type" );
		typeElement.setTextContent( versionInfo.getServerType().getTypeName() );
		serverElement.appendChild( typeElement );

		Element cloneElement = doc.createElement( "clonedate" );
		cloneElement.setTextContent( versionInfo.getCloneDate() );
		cloneElement.appendChild( typeElement );
	}
	
	// speechmike types handling
	String spmikeFilename = "spmiketypes.conf";
	String defaultSp = IMEnvBase.getEnv(  "DOWNLOAD_HOME"  ) + "/" + spmikeFilename;
	File defaultSpFile = new File( defaultSp );
	if( defaultSpFile.exists() ) {
		Element spmikeElement = doc.createElement( "spmiketypes" );
		ViewerProfileManager.addSpeechMikeList( defaultSp, spmikeFilename, doc, spmikeElement );
		serverElement.appendChild( spmikeElement );
	}
	
		// ha van a group-nak profile.xml-je, akkor az
	// ha nincs, akkor a var/conf/default_profile.xml 
	// ha nincs, akkor a download/viewerdefaults/default_profile.xml-bol
	String userdefaults = ViewerProfileManager.getGroupProfileData( is, "profile.xml" ).trim();
	if( userdefaults.length() == 0 ) {
		String siteFile = "/home/medsrv/var/conf/default_profile.xml";
		if( new File( siteFile ).exists() ) {
			userdefaults = Helper.readTextFile( siteFile );
		}
		else {
			userdefaults = Helper.readTextFile( "/home/medsrv/component/download/viewerdefaults/default_profile.xml" );
		}
	}

	String strProfileData = ViewerProfileManager.getUserProfileData( is, "profile.xml", false ).trim();
	
	// write xml data to string
	TransformerFactory transformerFactory = TransformerFactory.newInstance();
	Transformer transformer = transformerFactory.newTransformer();
	transformer.setOutputProperty( OutputKeys.OMIT_XML_DECLARATION, "yes" );
	transformer.setOutputProperty( OutputKeys.INDENT, "yes" );
	transformer.setOutputProperty( "{http://xml.apache.org/xslt}indent-amount", "8" );
	DOMSource source = new DOMSource( doc );
	StringWriter stw = new StringWriter();
	transformer.transform( source, new StreamResult( stw ) );
	result.append( stw.toString().trim() );
	
	String resStr = result.toString();

	// this hack is needed because:
	// we cannot put the files into a single tag, because the <> chars would then be decoded, which is wrong
	// and we don't want to parse the file to xml
	configtag = "<" + configtag + ">";
	
	int configpos = resStr.indexOf( configtag );
	if( configpos == -1 ) {
		Helper.ERRORLOG( "Hmm, getuserconfig result doesn't contain <config> tag..." + resStr );
	}
	else {
		StringBuffer newres = new StringBuffer( resStr.substring( 0, configpos + configtag.length() ) ); 
		if( userdefaults != null ) {
			newres.append( "\r\n\t<userdefault>\r\n\t\t" ).append( userdefaults ).append( "\r\n\t</userdefault>\r\n" );
		}
		newres.append( "\t" ).append( strProfileData ).append( "\r\n" );
		newres.append( resStr.substring( configpos + configtag.length() + 1 ) ); 
		resStr = newres.toString();
	}
	
	response.setContentType( "text/xml" );
//	response.setHeader( "Content-length", Long.toString( resStr.length() ) );
	response.setHeader( "Pragma", "no-cache" );

	out.println( resStr );

	
	if ( true ) {
		// For avoiding extra newline(s)
		return;
	}
%>
